package com.suncreate.kafkaConsumerMonitor.service;

import org.apache.http.HttpHost;
import org.elasticsearch.action.index.IndexRequest;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;

import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.util.UUID;

import org.elasticsearch.client.RestClient;
import org.elasticsearch.client.RestHighLevelClient;

@Service
public class Log2ESService {
    private static final Logger log = LoggerFactory.getLogger(Log2ESService.class);

    RestHighLevelClient client = null;

    private final SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSSZZ");

    private final SimpleDateFormat monthFormat = new SimpleDateFormat("yyyy-MM");

    @PostConstruct
    public void init() {
        try {
            client = new RestHighLevelClient(
                    RestClient.builder(
                            new HttpHost("xxx.xxx.xxx.93", 24100, "http"),
                            new HttpHost("xxx.xxx.xxx.94", 24100, "http"),
                            new HttpHost("xxx.xxx.xxx.95", 24100, "http"),
                            new HttpHost("xxx.xxx.xxx.96", 24100, "http"),
                            new HttpHost("xxx.xxx.xxx.98", 24100, "http"),
                            new HttpHost("xxx.xxx.xxx.99", 24100, "http"))
                            .setMaxRetryTimeoutMillis(5 * 60 * 1000));//超时时间设为5分钟
            log.info("Log2ESService init 成功");
        } catch (Exception e) {
            log.error("Log2ESService init error", e);
        }
    }

    @PreDestroy
    public void close() {
        try {
            client.close();
            log.info("Log2ESService close 成功");
        } catch (Exception e) {
            log.error("Log2ESService close error", e);
        }
    }

    public void log2ES(boolean success, String msg) throws Exception {
        try {
            String index = "logback-" + monthFormat.format(new Date());
            String doc = "doc";
            String id = UUID.randomUUID().toString();

            //保存到ES的source记录
            Map<String, Object> jsonMap = new HashMap<>();
            jsonMap.put("app", "kafka-delay-check");
            if (success) {
                jsonMap.put("operation_result", "成功");
            } else {
                jsonMap.put("operation_result", "失败");
            }
            jsonMap.put("message", msg);
            jsonMap.put("log_time", simpleDateFormat.format(new Date()));

            IndexRequest indexRequest = new IndexRequest(index, doc, id)
                    .source(jsonMap);
            client.index(indexRequest);
        } catch (Exception e) {
            log.error("Log2ESService log2ES error", e);
        }
    }
}
